#include "interpolate.h"

using kblib::variant_cast;

template <expr_e E>
using tag = std::integral_constant<std::size_t, kblib::etoi(E)>;

arg_t eval(const template_machine& tm, const tnode& expr,
           const ArgsType& args) {
	return kblib::visit_indexed(
	    expr.data,
	    [&](tag<expr_e::text>, const std::string& str) -> arg_t { return str; },
	    [&](tag<expr_e::argument>, int arg) -> arg_t {
		    return variant_cast<arg_t>(args[arg]);
	    },
	    [&](tag<expr_e::special_argument>, std::string_view arg) -> arg_t {
		    return variant_cast<arg_t>(args[tm.special_argument(arg)]);
	    },
	    [&](tag<expr_e::ellipsis>, std::monostate) -> arg_t {
		    return variant_cast<arg_t>(args[tm.special_argument("...")]);
	    },
	    [&](tag<expr_e::func>, const t_func* f) -> arg_t {
		    return f->eval(tm, args, expr.children);
	    });
}
